Security Considerations for Transient Numeric Identifiers Employed in Network Protocols
RFC 9416
BCP 72
Fernando Gont
SI6 Networks
Segurola y Habana 4310 7mo piso
Ciudad Autonoma de Buenos Aires
Argentina
fgont@si6networks.com
https://www.si6networks.com
Ivan Arce
Quarkslab
Segurola y Habana 4310 7mo piso
Ciudad Autonoma de Buenos Aires
Argentina
iarce@quarkslab.com
https://www.quarkslab.com
July 2023
sec
security
vulnerability
algorithm
attack
fingerprinting
Poor selection of transient numerical identifiers in protocols such as the TCP/IP suite has historically led to a number of attacks on implementations, ranging from Denial of Service (DoS) or data injection to information leakages that can be exploited by pervasive monitoring. Due diligence in the specification of transient numeric identifiers is required even when cryptographic techniques are employed, since these techniques might not mitigate all the associated issues. This document formally updates RFC 3552, incorporating requirements for transient numeric identifiers, to prevent flaws in future protocols and implementations.
Introduction
Networking protocols employ a variety of transient numeric identifiers for different protocol objects, such as IPv4 and IPv6 Identification values [RFC0791] [RFC8200], IPv6 Interface Identifiers (IIDs) [RFC4291], transport-protocol ephemeral port numbers [RFC6056], TCP Initial Sequence Numbers (ISNs) [RFC9293], NTP Reference IDs (REFIDs) [RFC5905], and DNS IDs [RFC1035]. These identifiers typically have specific requirements (e.g., uniqueness during a specified period of time) that must be satisfied such that they do not result in negative interoperability implications, and an associated failure severity when such requirements are not met [RFC9415].
NOTE: Some documents refer to the DNS ID as the DNS "Query ID" or "TxID".
For more than 30 years, a large number of implementations of IETF protocols have been subject to a variety of attacks, with effects ranging from Denial of Service (DoS) or data injection to information leakages that could be exploited for pervasive monitoring [RFC7258]. The root cause of these issues has been, in many cases, the poor selection of transient numeric identifiers in such protocols, usually as a result of insufficient or misleading specifications. While it is generally trivial to identify an algorithm that can satisfy the interoperability requirements of a given transient numeric identifier, empirical evidence exists that doing so without negatively affecting the security and/or privacy properties of the aforementioned protocols is prone to error [RFC9414].
For example, implementations have been subject to security and/or privacy issues resulting from:
- predictable IPv4 or IPv6 Identification values (e.g., see [Sanfilippo1998a], [RFC6274], and [RFC7739]),
- predictable IPv6 IIDs (e.g., see [RFC7217], [RFC7707], and [RFC7721]),
- predictable transport-protocol ephemeral port numbers (e.g., see [RFC6056] and [Silbersack2005]),
- predictable TCP Initial Sequence Numbers (ISNs) (e.g., see [Morris1985], [Bellovin1989], and [RFC6528]),
- predictable initial timestamps in TCP timestamps options (e.g., see [TCPT-uptime] and [RFC7323]), and
- predictable DNS IDs (see, e.g., [Schuba1993] and [Klein2007]).
Recent history indicates that, when new protocols are standardized or new protocol implementations are produced, the security and privacy properties of the associated transient numeric identifiers tend to be overlooked, and inappropriate algorithms to generate such identifiers are either suggested in the specifications or selected by implementers. As a result, advice in this area is warranted.
We note that the use of cryptographic techniques for confidentiality and authentication might not eliminate all the issues associated with predictable transient numeric identifiers. Therefore, due diligence in the specification of transient numeric identifiers is required even when cryptographic techniques are employed.
NOTE: For example, cryptographic authentication can readily mitigate data injection attacks even in the presence of predictable transient numeric identifiers (such as "sequence numbers"). However, use of flawed algorithms (such as global counters) for generating transient numeric identifiers could still result in information leakages even when cryptographic techniques are employed. These information leakages could in turn be leveraged to perform other devastating attacks (please see [RFC9415] for further details).
Section 3 provides an overview of common flaws in the specification of transient numeric identifiers. Section 4 provides an overview of common flaws in the generation of transient numeric identifiers and their associated security and privacy implications. Finally, Section 5 provides key guidelines for protocol designers.
Terminology
Transient Numeric Identifier:
A data object in a protocol specification that can be used to definitely distinguish a protocol object (a datagram, network interface, transport-protocol endpoint, session, etc.) from all other objects of the same type, in a given context. Transient numeric identifiers are usually defined as a series of bits and represented using integer values. These identifiers are typically dynamically selected, as opposed to statically assigned numeric identifiers (e.g., see [IANA-PROT]). We note that different transient numeric identifiers may have additional requirements or properties depending on their specific use in a protocol. We use the term "transient numeric identifier" (or simply "numeric identifier" or "identifier" as short forms) as a generic term to refer to any data object in a protocol specification that satisfies the identification property stated above.
Failure Severity:
The interoperability consequences of a failure to comply with the interoperability requirements of a given identifier. Severity considers the worst potential consequence of a failure, determined by the system damage and/or time lost to repair the failure. In this document, we define two types of failure severity: "soft" and "hard".
Soft Failure:
A recoverable condition in which a protocol does not operate in the prescribed manner but normal operation can be resumed automatically in a short period of time. For example, a simple packet-loss event that is subsequently recovered with a retransmission can be considered a soft failure.
Hard Failure:
A non-recoverable condition in which a protocol does not operate in the prescribed manner or it operates with excessive degradation of service. For example, an established TCP connection that is aborted due to an error condition constitutes, from the point of view of the transport protocol, a hard failure, since it enters a state from which normal operation cannot be recovered.
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
Issues with the Specification of Transient Numeric Identifiers
Recent work on transient numeric identifier usage in protocol specifications and implementations [RFC9414] [RFC9415] revealed that most of the issues discussed in this document arise as a result of one of the following conditions:
- protocol specifications that under specify their transient numeric identifiers
- protocol specifications that over specify their transient numeric identifiers
- protocol implementations that simply fail to comply with the specified requirements
Both under specifying and over specifying transient numeric identifiers is hazardous. TCP local ports [RFC0793], as well as DNS IDs [RFC1035], were originally under specified, leading to implementations that resulted in predictable values and thus were vulnerable to numerous off-path attacks. Over specification, as for IPv6 Interface Identifiers (IIDs) [RFC4291] and IPv6 Identification values [RFC2460], left implementations unable to respond to security and privacy issues stemming from the mandated or recommended algorithms -- IPv6 IIDs need not expose privacy-sensitive link-layer addresses, and predictable IPv6 Fragment Header Identification values invite the same off-path attacks that plague TCP.
Finally, there are protocol implementations that simply fail to comply with existing protocol specifications. That is, appropriate guidance is provided by the protocol specification (whether it be the core specification or an update to it), but an implementation simply fails to follow such guidance. For example, some popular operating systems still fail to implement transport-protocol port randomization, as specified in [RFC6056].
Clear specification of the interoperability requirements for the transient numeric identifiers will help identify possible algorithms that could be employed to generate them and also make evident if such identifiers are being over specified. A protocol specification will usually also benefit from a vulnerability assessment of the transient numeric identifiers they specify to prevent the corresponding considerations from being overlooked.
Common Flaws in the Generation of Transient Numeric Identifiers
This section briefly notes common flaws associated with the generation of transient numeric identifiers. Such common flaws include, but are not limited to:
- employing trivial algorithms (e.g., global counters) that result in predictable identifiers,
- employing the same identifier across contexts in which constancy is not required,
- reusing identifiers across different protocols or layers of the protocol stack,
- initializing counters or timers to constant values when such initialization is not required,
- employing the same increment space across different contexts, and
- use of flawed Pseudorandom Number Generators (PRNGs).
Employing trivial algorithms for generating the identifiers means that any node that is able to sample such identifiers can easily predict future identifiers employed by the victim node.
When one identifier is employed across contexts where such constancy is not needed, activity correlation is made possible. For example, employing an identifier that is constant across networks allows for node tracking across networks.
Reusing identifiers across different layers or protocols ties the security and privacy properties of the protocol reusing the identifier to the security and privacy properties of the original identifier (over which the protocol reusing the identifier may have no control regarding its generation). Besides, when reusing an identifier across protocols from different layers, the goal of isolating the properties of a layer from those of another layer is broken, and the vulnerability assessment may be harder to perform since the combined system, rather than each protocol in isolation, will have to be assessed.
At times, a protocol needs to convey order information (whether it be sequence, timing, etc.). In many cases, there is no reason for the corresponding counter or timer to be initialized to any specific value, e.g., at system bootstrap. Similarly, there may not be a need for the difference between successive counter values to be predictable.
A node that implements a per-context linear function may share the increment space among different contexts (please see the "Simple PRF-Based Algorithm" section in [RFC9415]). Sharing the same increment space allows an attacker that can sample identifiers in other context to, e.g., learn how many identifiers have been generated between two sampled values.
Finally, some implementations have been found to employ flawed PRNGs (e.g., see [Klein2007]).
Requirements for Transient Numeric Identifiers
Protocol specifications that employ transient numeric identifiers MUST explicitly specify the interoperability requirements for the aforementioned transient numeric identifiers (e.g., required properties such as uniqueness, along with the failure severity if such requirements are not met).
A vulnerability assessment of the aforementioned transient numeric identifiers MUST be performed as part of the specification process. Such vulnerability assessment should cover, at least, spoofing, tampering, repudiation, information disclosure, DoS, and elevation of privilege.
NOTE: Sections 8 and 9 of [RFC9415] provide a general vulnerability assessment of transient numeric identifiers, along with a vulnerability assessment of common algorithms for generating transient numeric identifiers. Please see [Shostack2014] for further guidance on threat modeling.
Protocol specifications SHOULD NOT employ predictable transient numeric identifiers, except when such predictability is the result of their interoperability requirements.
Protocol specifications that employ transient numeric identifiers SHOULD recommend an algorithm for generating the aforementioned transient numeric identifiers that mitigates the vulnerabilities identified in the previous step, such as those discussed in [RFC9415].
As discussed in Section 1, use of cryptographic techniques for confidentiality and authentication might not eliminate all the issues associated with predictable transient numeric identifiers. Therefore, the advice from this section MUST still be applied for cases where cryptographic techniques for confidentiality or authentication are employed.
IANA Considerations
This document has no IANA actions.
Security Considerations
This entire document is about the security and privacy implications of transient numeric identifiers and formally updates [RFC3552] such that the security and privacy implications of transient numeric identifiers are addressed when writing the "Security Considerations" section of future RFCs.
References
Normative References
Informative References
[Sanfilippo1998a]

about the ip header id
Salvatore Sanfilippo
December 1998
message to the Bugtraq mailing list
[Bellovin1989]

Security Problems in the TCP/IP Protocol Suite
S. M. Bellovin
April 1989
Computer Communications Review, vol. 19, no. 2, pp. 32-48
[Morris1985]

A Weakness in the 4.2BSD UNIX TCP/IP Software
Robert Morris
February 1985
CSTR 117, AT&T Bell Laboratories, Murray Hill, NJ
[Silbersack2005]

Improving TCP/IP security through randomization without sacrificing interoperability
Michael James Silbersack
The FreeBSD Project
January 2005
EuroBSDCon 2005 Conference
[TCPT-uptime]

TCP Timestamping - Obtaining System Uptime Remotely
Bret McDanel
Securiteam
March 2001
message to the Bugtraq mailing list
[Klein2007]

OpenBSD DNS Cache Poisoning and Multiple O/S Predictable IP ID Vulnerability
Amit Klein
Trusteer
October 2007
[Schuba1993]

Addressing Weakness in the Domain Name System Protocol
Christoph Schuba
August 1993
[Shostack2014]

Threat Modeling: Designing for Security
Adam Shostack
February 2014
Wiley, 1st edition
[RFC9414]

Unfortunate History of Transient Numeric Identifiers
Fernando Gont
Ivan Arce
July 2023
RFC 9414
DOI 10.17487/RFC9414
[RFC9415]

On the Generation of Transient Numeric Identifiers
Fernando Gont
Ivan Arce
July 2023
RFC 9415
DOI 10.17487/RFC9415
[IANA-PROT]

Protocol Registries
IANA
[RFC0791]
[RFC8200]
[RFC4291]
[RFC6056]
[RFC9293]
[RFC5905]
[RFC1035]
[RFC7258]
[RFC6274]
[RFC7739]
[RFC7217]
[RFC7707]
[RFC7721]
[RFC6528]
[RFC7323]
[RFC2119]
[RFC8174]
[RFC0793]
[RFC2460]
[RFC3552]
[I-D.gont-predictable-numeric-ids]
Acknowledgements
The authors would like to thank (in alphabetical order) Bernard Aboba, Brian Carpenter, Roman Danyliw, Theo de Raadt, Lars Eggert, Russ Housley, Benjamin Kaduk, Charlie Kaufman, Erik Kline, Alvaro Retana, Joe Touch, Michael Tüxen, Robert Wilton, and Paul Wouters for providing valuable comments on draft versions of this document.
The authors would like to thank (in alphabetical order) Steven Bellovin, Joseph Lorenzo Hall, and Gre Norcie for providing valuable comments on [I-D.gont-predictable-numeric-ids], on which the present document is based.
The authors would like to thank Diego Armando Maradona for his magic and inspiration.